/*
 * Copyright (C) 1990 Democracy News Propaganda System.
 * Version 1.00
 * Produced By TheDog
 * All Rights Reserved
 *
 * This program with convert a chinese article,
 * Provided by the Society of HKU Postgraduates on the Chinese Affairs,
 * into a Postscript program which is printable on postscript printers.
 *
 * July 2, 1990.
 *
 */
#include <stdio.h>

#define	ZITAPE	"chinese.16"
#define HEIGHT	16

char	filename[100];
char	dictname[100];
char	buffer[16][200];
FILE	*fp;
char	inbuf[512];
FILE	*bitmap;
char	charinline;
int	hpos,vpos;

main (argc,argv)
int	argc;
char	**argv;
{
char	ch;
unsigned char	ch1,ch2;
int	charno;
char	charcnt;

	*filename=0;
	*dictname=0;
	charinline=5;
	while (--argc)
	{
		if ((*++argv)[0] == '-')
			switch ((*argv)[1])
			{
			 case 'w':
				charinline=atoi (*argv+2);
				break;
			 case 'd':
				strcpy (dictname,*argv+2);
				break;
			}
		else
			strcpy (filename,*argv);
	}
	if (*filename==0)
	{
		printf ("\7No file given\n");
		exit ();
	}
	if (*dictname==0)
		strcpy (dictname,ZITAPE);
#ifdef unix
	if ((fp=fopen(filename,"r"))==NULL)
#else
	if ((fp=fopen(filename,"rb"))==NULL)
#endif
	{
		printf ("\7Can't open file - %s\n",filename);
		exit ();
	}

	initps ();
	header ();
	while ((ch=fgetc (fp))!=EOF)
	{
		ch1 = ch;
		if (ch1==13 || ch1==26)
			nextline ();
		else if (ch1>=0x81)
		{
			if ((ch=fgetc (fp))==EOF)
			{
				printf ("\7File read error!\n");
				exit ();
			}
			ch2=ch;
			getbitmap (order(ch1,ch2));
			putbitmap ();
		}
		else
			if (map (ch,&ch1,&ch2) == 0)
			{
				getbitmap (order(ch1,ch2));
				putbitmap ();
			}
	}
	logo ();
	footer ();
}

order (fontid,glyphid)
unsigned char	fontid,glyphid;
{
int	charno;
	if (fontid<0xA4)
	{
		if (glyphid<0x7F)
			charno=(fontid-0xA1)*157+(glyphid-0x40);
		else
			charno=(fontid-0xA1)*157+(glyphid-0xA1)+(0x7E-0x40+1);
	}
	else
	{
		if (glyphid<0x7F)
			charno=(fontid-0xA4)*157+(glyphid-0x40);
		else
			charno=(fontid-0xA4)*157+(glyphid-0xA1)+(0x7E-0x40+1);
		charno += 765;
	}
	return (charno);
}



getbitmap (glyphid)
int	glyphid;
{
long	absaddr;
int	i;
int	ch, tch;

	absaddr = (long)glyphid*32;
	absaddr += 256;

	if ((bitmap = fopen (dictname, "rb"))==NULL)
	{
		fprintf(stderr,"news2ps : Cannot open the bitmap file - %s\n",
						dictname);
		fprintf(stderr,"          Aborted\7\n");
		exit (-1);
	}
	fseek (bitmap, absaddr, 0);
	for (i=0; i<32; i++)
		fscanf (bitmap,"%c",&inbuf[i]);
	fclose (bitmap);
}

char	chmap[] = {'0', '1', '2', '3', '4', '5', '6', '7',
		   '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
putbitmap ()
{
int	i;
char	tch,ch;

	printf ("%d H %d V gsave currentpoint translate\n",hpos, vpos);
	printf ("10 10 scale\n");
	printf ("16 16 true [16 0 0 -16 0 16]\n");
	printf ("{<");
	for (i=0; i<32; i++)
	{
		tch = inbuf[i];
		ch = 017 & (tch >> 4);
		printf ("%c", chmap[ch]);
		ch = 017 & inbuf[i];
		printf ("%c", chmap[ch]);
	}
	printf (">} imagemask\n");
	printf ("grestore\n");
	hpos+=90;
	if (hpos>4700)
		nextline ();
}

nextline ()
{
	vpos += 100;
	if (vpos> 6300)
	{
		footer ();
		header ();
	}
	hpos=267;
}

footer ()
{
	printf ("6336 V\nrestore\nnewpage\n");
}

header ()
{
	printf ("save\n0 0 moveto\n");
	vpos=768;
	hpos=267;
}

initps ()
{
	printf ("%%!PS-HKU\n");
	printf ("/H {8 div currentpoint exch pop moveto} def\n");
	printf ("/V {8 div 846 exch sub currentpoint pop exch moveto} def\n");
	printf ("/newpage { showpage } def\n");
	printf ("\n\n%%!End of Prolog\n");
}

map  (inchar, fontcode, charcode)
char	inchar;
char	*fontcode, *charcode;
{
	*fontcode= 0xA1; *charcode= 0x40;	/* space */
	if (inchar == '\t')
		return (0);
	if (inchar < 0x20)
		return (-1);
	switch (inchar)
	{
	 case 'A': case 'B': case 'C': case 'D':
	 case 'E': case 'F': case 'G': case 'H':
	 case 'I': case 'J': case 'K': case 'L':
	 case 'M': case 'N': case 'O': case 'P':
	 case 'Q': case 'R': case 'S': case 'T':
	 case 'U': case 'V': case 'W': case 'X':
	 case 'Y': case 'Z':
		*fontcode= 0xA2; *charcode= 0xCF+inchar-'A';
		break;
	 case 'a': case 'b': case 'c': case 'd':
	 case 'e': case 'f': case 'g': case 'h':
	 case 'i': case 'j': case 'k': case 'l':
	 case 'm': case 'n': case 'o': case 'p':
	 case 'q': case 'r': case 's': case 't':
	 case 'u': case 'v':
		*fontcode= 0xA2; *charcode= 0xE9+inchar-'a';
		break;
	 case 'w': case 'x': case 'y': case 'z':
		*fontcode= 0xA3; *charcode= 0x40+inchar-'w';
		break;
	 case '0': case '1': case '2': case '3':
	 case '4': case '5': case '6': case '7':
	 case '8': case '9':
		*fontcode= 0xA2; *charcode= 0xAF+inchar-'0';
		break;
	 case ',':
		*fontcode= 0xA1; *charcode= 0x41;
		break;
	 case '.':
		*fontcode= 0xA1; *charcode= 0x44;
		break;
	 case ';':
		*fontcode= 0xA1; *charcode= 0x46;
		break;
	 case ':':
		*fontcode= 0xA1; *charcode= 0x47;
		break;
	 case '?':
		*fontcode= 0xA1; *charcode= 0x48;
		break;
	 case '!':
		*fontcode= 0xA1; *charcode= 0x49;
		break;
	 case '|':
		*fontcode= 0xA1; *charcode= 0x57;
		break;
	 case '(':
		*fontcode= 0xA1; *charcode= 0x5D;
		break;
	 case ')':
		*fontcode= 0xA1; *charcode= 0x5E;
		break;
	 case '{':
		*fontcode= 0xA1; *charcode= 0x61;
		break;
	 case '}':
		*fontcode= 0xA1; *charcode= 0x62;
		break;
	 case '[':
		*fontcode= 0xA1; *charcode= 0x65;
		break;
	 case ']':
		*fontcode= 0xA1; *charcode= 0x66;
		break;
	 case '<':
		*fontcode= 0xA1; *charcode= 0x71;
		break;
	 case '>':
		*fontcode= 0xA1; *charcode= 0x72;
		break;
	 case '\"':
		*fontcode= 0xA1; *charcode= 0xAA;
		break;
	 case '`':
		*fontcode= 0xA1; *charcode= 0xAB;
		break;
	 case '\'':
		*fontcode= 0xA1; *charcode= 0xAC;
		break;
	 case '#':
		*fontcode= 0xA1; *charcode= 0xAD;
		break;
	 case '&':
		*fontcode= 0xA1; *charcode= 0xAE;
		break;
	 case '*':
		*fontcode= 0xA1; *charcode= 0xAF;
		break;
	 case '_':
		*fontcode= 0xA1; *charcode= 0xC4;
		break;
	 case '+':
		*fontcode= 0xA1; *charcode= 0xDE;
		break;
	 case '-':
		*fontcode= 0xA1; *charcode= 0xDF;
		break;
	 case '=':
		*fontcode= 0xA1; *charcode= 0xE2;
		break;
	 case '~':
		*fontcode= 0xA1; *charcode= 0xE3;
		break;
	 case '^':
		*fontcode= 0xA1; *charcode= 0xF4;
		break;
	 case '/':
		*fontcode= 0xA2; *charcode= 0x41;
		break;
	 case '\\':
		*fontcode= 0xA2; *charcode= 0x42;
		break;
	 case '$':
		*fontcode= 0xA2; *charcode= 0x43;
		break;
	 case '%':
		*fontcode= 0xA2; *charcode= 0x48;
		break;
	 case '@':
		*fontcode= 0xA2; *charcode= 0x49;
		break;
	}
	return (0);
}

logo ()
{
	printf ("%d H %d V gsave currentpoint translate\n",hpos,vpos);
	printf ("0.96 0.96 scale\n");
	printf ("192 121 true [4 0 0 -4 0 4]\n");
	printf ("{<\n");
	printf ("000000000000000000000000000000000000000000000000\n");
	printf ("000000000000000000000200000000000000000000000000\n");
	printf ("000000000000000001FFFFFFFFC000000000000000000000\n");
	printf ("00000000000000003FFFFFFFFFFE00000000000000000000\n");
	printf ("000000000000000FFFFF00007FFFFC000000000000000000\n");
	printf ("000000000000007FFFE0000003FFFF000000000000000000\n");
	printf ("00000000000007FFC007FFFFE0007FF80000000000000000\n");
	printf ("0000000000003FFC01FFFFFFFFC00FFE0000000000000000\n");
	printf ("000000000003FF80FF800000007FC03FE000000000000000\n");
	printf ("00000000000FFC07F00000000003F80FF800000000000000\n");
	printf ("00000000007FE0F800000000000007C07F00000000000000\n");
	printf ("0000000000FF03E000000000000001F03F80000000000000\n");
	printf ("0000000007F87C0000198CC00780000F07F0000000000000\n");
	printf ("000000000FE1F00001998CC007C00003C1FC000000000000\n");
	printf ("000000007F0F0000318B0CC0066000003C3F800000000000\n");
	printf ("00000000FE3C0000118E0CC0066000000E1FC00000000000\n");
	printf ("00000003F1F00180198F0CC006C7800001C1F00000000000\n");
	printf ("0000000FE3C003001F8F0CC00FCD8C1000E1F80000000000\n");
	printf ("0000003F8E000380188D8CC00C189E3000183E0000000000\n");
	printf ("0000003E3C000380188D8CC00C199A70000E1F0000000000\n");
	printf ("000000F8F000308018CCC7800C199C31000187C000000000\n");
	printf ("000001F1C000788008C8030008198C238000C3E000000000\n");
	printf ("000007C700008CC008000000000F2666E00038F800000000\n");
	printf ("000007CE0000CCC000000000000236664000187800000000\n");
	printf ("00001F3C000064C0000FFFFFF800084CC700061E00000000\n");
	printf ("00003E300000644003FFFFFFFFC0006CC700031E00000000\n");
	printf ("000078C000003C00FF800000003F8005887000C780000000\n");
	printf ("0000F9C006001C03F80000000007E0079870006780000000\n");
	printf ("0003E3000600003F0000000000003F0B10180031E0000000\n");
	printf ("0003C600360000FC00000000000007CE10F00019F0000000\n");
	printf ("00078C03BF00078000000000000000780131D80C78000000\n");
	printf ("000F18038F001F00000000000000001E0123F0067C000000\n");
	printf ("001E30038700F800000000000000000380E660031E000000\n");
	printf ("001C6000C301E0000000000000000001E06660010E000000\n");
	printf ("003CC01C618700000000000000000000380CC000CF000000\n");
	printf ("0079803C798E000000000000000000001C0CC600C7800000\n");
	printf ("00F3002633380000000000000000000003038C0033800000\n");
	printf ("01F3003D0070000000000000000000000181188031C00000\n");
	printf ("01E4041981C0000000000000000000000060218019C00000\n");
	printf ("03C4051D8380000300000000000010000060230009E00000\n");
	printf ("038801C70600000780003000C001BF0000183C0004E00000\n");
	printf ("071800C00C00000F003B3000E003330000081C3006700000\n");
	printf ("0730003018000003F01DFC00C0039F000006000802780000\n");
	printf ("0E300E103000001FF80BFC0040013F00000701C802380000\n");
	printf ("0E6018C0700000FF00612C005E01B2000001823801380000\n");
	printf ("0C6018C0600000CFC061FE03FE0597E000008370019C0000\n");
	printf ("1CC00C40C000003B382FB00EC00798E0000040C3819C0000\n");
	printf ("1CC007C1800000731C09B000C0045C8000006083809C0000\n");
	printf ("3D8001C1800000DFC0137800B00C30000000201D000E0000\n");
	printf ("398000030000009EC017FE019000170000002038004E0000\n");
	printf ("31007C020000001FC07D67830C07FB8000001060004E0000\n");
	printf ("3300DE060000000EC069C387060310000000182000470000\n");
	printf ("7300C3060000001FC061F81C078010000000080780670000\n");
	printf ("7200E30C0000001FC021FC1003C010000000080FC0270000\n");
	printf ("72003E0C00000000C00000000000700000000412C0270000\n");
	printf ("72000C0C00000000000000000000200000000410C0278000\n");
	printf ("720000180000000000000000000000000000040800238000\n");
	printf ("620000180000000000000000000000000000060000238000\n");
	printf ("62067C180000000000000000000000002000060000238000\n");
	printf ("62067C100000000700018000000030003000060DC0238000\n");
	printf ("620CC618001C08030001C003FE0198007000060960238000\n");
	printf ("6204C618007F9C03F001C01FF6019000C800060960238000\n");
	printf ("62079C180037387FFC0CC0089601D0019600060EE0238000\n");
	printf ("62031C180033186D9C1DF81886011003D300060E80238000\n");
	printf ("420000180067BF4CC01FF8084601F0061FC0040000278000\n");
	printf ("6200001800FFFE4CE03F8008D6011E0FE7E0040000278000\n");
	printf ("5200000C01CF1807C060800BF61F1B01BE00040000270000\n");
	printf ("7200000C01CB180FC001F00BA61E000176000C0000670000\n");
	printf ("7300000C007A187C800FC01BF6037801FC00080000470000\n");
	printf ("330000060062180D8001801F560740008000180000470000\n");
	printf ("310000060004181984018018FE0DE001CC001000004E0000\n");
	printf ("31000003000C183986018C1FFE18E001AC001000004E0000\n");
	printf ("3980310300001860FE7FFE180E203E018C002032008E0000\n");
	printf ("09803F01800000407E78020006001FC1FC006036009C0000\n");
	printf ("1CC01F00C000000000000000000002008800403E019C0000\n");
	printf ("1CC01FC0C000000000000000000000000800C0FC019C0000\n");
	printf ("0C601FE0600000000000000000000000000181EE03380000\n");
	printf ("0E603F007000000000000000000000000003002F02380000\n");
	printf ("0E300700180000000000000000000000000E003006700000\n");
	printf ("071003000C0000000000000000000000000C001006700000\n");
	printf ("03980000060000000000000000000000001800000CE00000\n");
	printf ("038C00000700000000000000000000000030000009E00000\n");
	printf ("03C4000001800000000000000000000000E0000019C00000\n");
	printf ("01E6000000C00000000000000000000001C0000033C00000\n");
	printf ("00E300000070000000000000000000000700000067800000\n");
	printf ("00F38000003C000000000000000000000E000000E7800000\n");
	printf ("0078C000000700000000000000000000380000018E000000\n");
	printf ("0038C000000380000000000000000000700000018E000000\n");
	printf ("001C70001E00F0000000000000000003C00000063C000000\n");
	printf ("000E30003F003C000000000000000007000000063C000000\n");
	printf ("00071C0073000F800000000000000078001E000CF8000000\n");
	printf ("00078C00630003E000000000000001F000120019F0000000\n");
	printf ("0003C700C300007F0000000000000F80009F8073E0000000\n");
	printf ("0001E300C620001FC000000000007E00319F8067C0000000\n");
	printf ("0000F8C0CC780000FF000000001FC0000180818F00000000\n");
	printf ("000078E0CCFC00003FFC000007FE00001987839F00000000\n");
	printf ("00001E3078CC000000FFFFFFFF80006108800E3E00000000\n");
	printf ("00001F1C019800700001FFFFE00000638C801C7C00000000\n");
	printf ("000007C7013000F80000000000000476C46071F000000000\n");
	printf ("000003C3813000D8C000000000010C76C440E3E000000000\n");
	printf ("000000F0E03001888300000000038E21E6038F8000000000\n");
	printf ("000000FC302003098300000000038E3162071F8000000000\n");
	printf ("0000003F0E000301F20000000003C611F0387E0000000000\n");
	printf ("0000001F87000301B33C00000002C211C070FC0000000000\n");
	printf ("00000007E0E00333323E7CE3C003E2180387E00000000000\n");
	printf ("00000001F070033322367DF3C003E310070FC00000000000\n");
	printf ("000000007E0F00E326267D83E0023100787F000000000000\n");
	printf ("000000003F03C00326267CE3E0023001E0FE000000000000\n");
	printf ("0000000007F07C0026644C326002001E07F0000000000000\n");
	printf ("0000000003FC1F8006644D936000007807E0000000000000\n");
	printf ("00000000007FC0FC000478F1C0001FC1FF00000000000000\n");
	printf ("00000000003FF03F8000306080007E07FC00000000000000\n");
	printf ("000000000003FF00FF80000000FFC07FE000000000000000\n");
	printf ("000000000000FFE00FFE80007FFC01FF8000000000000000\n");
	printf ("0000000000000FFF8007FFFFF000FFF80000000000000000\n");
	printf ("00000000000003FFF8000000000FFFE00000000000000000\n");
	printf ("000000000000001FFFFE00007FFFF8000000000000000000\n");
	printf ("0000000000000003FFFFFFFFFFFFC0000000000000000000\n");
	printf ("000000000000000003FFFFFFFFE000000000000000000000\n");
	printf ("0000000000000000001FFFFFFC0000000000000000000000\n");
	printf ("000000000000000000000000000000000000000000000000\n");
	printf (">} imagemask\n");
	printf ("grestore\n");
}
